import joi, { ObjectSchema, ValidationError as JoiValidationError, ValidationOptions } from 'joi';
import { ValidationError, RequestValidator } from '../types';
export declare const resolveValidationError: (valError: JoiValidationError | undefined) => ValidationError;
export declare const validateRequest: <T>(schema: ObjectSchema, data: T, options?: ValidationOptions) => void;
export declare const validateRequestAsync: <T>(schema: ObjectSchema, data: T, options?: ValidationOptions) => Promise<void>;
export declare const failValidationForField: (field: string, errorMessage: string) => never;
/**
 * This function can be used to validate both multiple-file upload and single upload
 */
export declare const validateFile: <T>(value: T | null, field: string, message?: string) => void;
/**
 * This function can be used to validate both multiple-file upload and single upload
 */
export declare const validateImage: <T>(value: T | null, field: string, message?: string) => void;
/**
 * This function can be used to validate both multiple-file upload and single upload
 */
export declare const validateFileExtension: (value: unknown, field: string, allowedExtensions: string[], message?: string) => void;
export declare function ValidateRequest(schemaOrValidator: joi.ObjectSchema | RequestValidator): (target: unknown, propertyKey: string, descriptor: PropertyDescriptor) => PropertyDescriptor;
export declare const ValidateRequestAsync: (schemaOrValidator: joi.ObjectSchema | RequestValidator) => (scope: unknown, methodName: string, descriptor: PropertyDescriptor) => void;
